import { AppOperativosType } from "operativos";
import { Constructor, Request, AppBackend, TablaDatos } from "./types-datos-ext";
export * from "./types-datos-ext";
export declare function emergeAppDatosExt<T extends Constructor<AppOperativosType>>(Base: T): {
    new (...args: any[]): {
        configStaticConfig(): void;
        generateBaseTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinition;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        clientIncludes(req: Request, hideBEPlusInclusions?: boolean | undefined): import("backend-plus").ClientModuleDefinition[];
        prepareGetTables(): void;
        tablasDatos: any[];
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        // mixin-patch: postConfig: (() => Promise<void>) & ((...params: any[]) => any);
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: any): import("backend-plus").TableDefinitionFunction;
        // mixin-patch: getMenu: (() => import("operativos").MenuDefinition) & ((context?: import("backend-plus").Context | undefined) => import("backend-plus").MenuDefinition);
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        } & {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        // mixin-patch: start: ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>) & ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>);
        // mixin-patch: getTables: (() => import("backend-plus").TableItemDef[]) & (() => import("backend-plus").TableItemDef[]);
        // mixin-patch: appendToTableDefinition: ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void) & ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void);
        // mixin-patch: getContext: ((req: Request) => import("backend-plus").Context) & ((req: Request) => import("backend-plus").Context);
        // mixin-patch: addSchrödingerServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void);
        // mixin-patch: addUnloggedServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void);
        // mixin-patch: addLoggedServices: (() => void) & (() => void);
        // mixin-patch: inDbClient: (<T_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>) & (<T_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>);
        // mixin-patch: inTransaction: (<T_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>) & (<T_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>);
        // mixin-patch: procedureDefCompleter: ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef) & ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef);
        // mixin-patch: tableDefAdapt: ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition) & ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition);
        // mixin-patch: pushApp: ((dirname: string) => void) & ((dirname: string) => void);
        dumpDbSchemaPartial: ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: {
            complete?: boolean | undefined;
            skipEnance?: boolean | undefined;
        } | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>) & ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: {
            complete?: boolean | undefined;
            skipEnance?: boolean | undefined;
        } | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>);
        // mixin-patch: getContextForDump: (() => import("backend-plus").ContextForDump) & (() => import("backend-plus").ContextForDump);
        // mixin-patch: getClientSetupForSendToFrontEnd: ((req: Request) => import("backend-plus").ClientSetup) & ((req: Request) => import("backend-plus").ClientSetup);
        // mixin-patch: configList: (() => (string | object)[]) & (() => (string | object)[]);
        // mixin-patch: setStaticConfig: ((defConfigYamlString: string) => void) & ((defConfigYamlString: string) => void);
    };
} & T;
export declare var AppDatosExt: {
    new (...args: any[]): {
        configStaticConfig(): void;
        generateBaseTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinition;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        clientIncludes(req: Request, hideBEPlusInclusions?: boolean | undefined): import("backend-plus").ClientModuleDefinition[];
        prepareGetTables(): void;
        tablasDatos: any[];
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        // mixin-patch: postConfig: (() => Promise<void>) & ((...params: any[]) => any);
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: any): import("backend-plus").TableDefinitionFunction;
        // mixin-patch: getMenu: (() => import("operativos").MenuDefinition) & ((context?: import("backend-plus").Context | undefined) => import("backend-plus").MenuDefinition);
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        } & {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        // mixin-patch: start: ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>) & ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>);
        // mixin-patch: getTables: (() => import("backend-plus").TableItemDef[]) & (() => import("backend-plus").TableItemDef[]);
        // mixin-patch: appendToTableDefinition: ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void) & ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void);
        // mixin-patch: getContext: ((req: Request) => import("backend-plus").Context) & ((req: Request) => import("backend-plus").Context);
        // mixin-patch: addSchrödingerServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void);
        // mixin-patch: addUnloggedServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void);
        // mixin-patch: addLoggedServices: (() => void) & (() => void);
        // mixin-patch: inDbClient: (<T>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T>) => Promise<T>) & (<T>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T>) => Promise<T>);
        // mixin-patch: inTransaction: (<T>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T>) => Promise<T>) & (<T>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T>) => Promise<T>);
        // mixin-patch: procedureDefCompleter: ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef) & ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef);
        // mixin-patch: tableDefAdapt: ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition) & ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition);
        // mixin-patch: pushApp: ((dirname: string) => void) & ((dirname: string) => void);
        dumpDbSchemaPartial: ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: {
            complete?: boolean | undefined;
            skipEnance?: boolean | undefined;
        } | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>) & ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: {
            complete?: boolean | undefined;
            skipEnance?: boolean | undefined;
        } | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>);
        // mixin-patch: getContextForDump: (() => import("backend-plus").ContextForDump) & (() => import("backend-plus").ContextForDump);
        // mixin-patch: getClientSetupForSendToFrontEnd: ((req: Request) => import("backend-plus").ClientSetup) & ((req: Request) => import("backend-plus").ClientSetup);
        // mixin-patch: configList: (() => (string | object)[]) & (() => (string | object)[]);
        // mixin-patch: setStaticConfig: ((defConfigYamlString: string) => void) & ((defConfigYamlString: string) => void);
    };
} & {
    new (...args: any[]): {
        tablasDatos: any[];
        configStaticConfig(): void;
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        postConfig(): Promise<void>;
        generateBaseTableDef(tablaDatos: any): import("backend-plus").TableDefinition;
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: any): import("backend-plus").TableDefinitionFunction;
        clientIncludes(req: Request, hideBEPlusInclusions: boolean): import("backend-plus").ClientModuleDefinition[];
        getMenu(): import("operativos").MenuDefinition;
        prepareGetTables(): void;
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        start(opts?: import("backend-plus").StartOptions | undefined): Promise<void>;
        getTables(): import("backend-plus").TableItemDef[];
        appendToTableDefinition(tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void): void;
        getContext(req: Request): import("backend-plus").Context;
        addSchrödingerServices(mainApp: import("backend-plus").ExpressPlus, baseUrl: string): void;
        addUnloggedServices(mainApp: import("backend-plus").ExpressPlus, baseUrl: string): void;
        addLoggedServices(): void;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        inDbClient<T_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1>): Promise<T_1>;
        inTransaction<T_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_1>): Promise<T_1>;
        procedureDefCompleter(procedureDef: import("backend-plus").ProcedureDef): import("backend-plus").ProcedureDef;
        tableDefAdapt(tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context): import("backend-plus").TableDefinition;
        pushApp(dirname: string): void;
        dumpDbSchemaPartial(partialTableStructures: import("backend-plus").TableDefinitions, opts?: {
            complete?: boolean | undefined;
            skipEnance?: boolean | undefined;
        } | undefined): Promise<{
            mainSql: string;
            enancePart: string;
        }>;
        getContextForDump(): import("backend-plus").ContextForDump;
        getClientSetupForSendToFrontEnd(req: Request): import("backend-plus").ClientSetup;
        configList(): (string | object)[];
        setStaticConfig(defConfigYamlString: string): void;
    };
    prefixTableName(tableName: string, prefix: string): string;
} & typeof AppBackend;
//# sourceMappingURL=app-datos-ext.d.ts.map